Index: trunk/NEMO/LIM_SRC/limistate.F90
===================================================================
--- trunk/NEMO/LIM_SRC/limistate.F90	(revision 716)
+++ trunk/NEMO/LIM_SRC/limistate.F90	(revision 717)
@@ -4,7 +4,9 @@
    !!              Initialisation of diagnostics ice variables
    !!======================================================================
-   !! History :   2.0  !  01-04  (C. Ethe, G. Madec)  Original code
+   !! History :   1.0  !  01-04  (C. Ethe, G. Madec)  Original code
+   !!             2.0  !  03-08  (G. Madec)  add lim_istate_init
    !!                  !  04-04  (S. Theetten) initialization from a file
    !!                  !  06-07  (S. Masson)  IOM to read the restart
+   !!                  !  07-10  (G. Madec)  surface module
    !!--------------------------------------------------------------------
 #if defined key_ice_lim
@@ -18,11 +20,9 @@
    USE phycst
    USE ocfzpt
-   USE oce             ! dynamics and tracers variables      !!gm used???
-   USE dom_oce                                                     !!gm used???
    USE par_ice         ! ice parameters
    USE ice_oce         ! ice variables
    USE dom_ice
-   USE ice             ! ???
    USE lbclnk
+   USE oce
    USE ice
    USE iom
@@ -32,7 +32,7 @@
    PRIVATE
 
-   PUBLIC lim_istate      ! routine called by lim_init.F90
-
-   REAL(wp) ::           &  !!! ** init namelist (namiceini) **
+   PUBLIC   lim_istate   ! routine called by lim_init.F90
+
+   REAL(wp) ::           & !!! ** init namelist (namiceini) **
       ttest  = 2.0  ,    &  ! threshold water temperature for initial sea ice
       hninn  = 0.5  ,    &  ! initial snow thickness in the north
@@ -67,46 +67,8 @@
       REAL(wp), DIMENSION(jpi,jpj) ::   ztn   ! workspace
       !--------------------------------------------------------------------
-
-       CALL lim_istate_init     !  reading the initials parameters of the ice
-
-      !-- Initialisation of sst,sss,u,v do i=1,jpi
-      u_io(:,:)  = 0.e0       ! ice velocity in x direction
-      v_io(:,:)  = 0.e0       ! ice velocity in y direction
-
-      IF( ln_limini ) THEN    ! 
-        
-         ! Initialisation at tn if no ice or sst_ini if ice
-         ! Idem for salinity
-
-      !--- Criterion for presence (zidto=1.) or absence (zidto=0.) of ice
-         DO jj = 1 , jpj
-            DO ji = 1 , jpi
-               
-               zidto = MAX(zzero, - SIGN(1.,frld(ji,jj) - 1.))
-               
-               sst_io(ji,jj) = ( nfice - 1 ) * (zidto * sst_ini(ji,jj)  + &   ! use the ocean initial values
-                    &          (1.0 - zidto ) * ( tn(ji,jj,1) + rt0 ))        ! tricky trick *(nfice-1) !
-               sss_io(ji,jj) = ( nfice - 1 ) * (zidto * sss_ini(ji,jj) + &
-                    &          (1.0 - zidto ) *  sn(ji,jj,1) )
-
-               ! to avoid the the melting of ice, several layers (mixed layer) should be
-               ! set to sst_ini (sss_ini) if there is ice
-               ! example for one layer 
-               ! tn(ji,jj,1) = zidto * ( sst_ini(ji,jj) - rt0 )  + (1.0 - zidto ) *  tn(ji,jj,1)
-               ! sn(ji,jj,1) = zidto * sss_ini(ji,jj)  + (1.0 - zidto ) *  sn(ji,jj,1)
-               ! tb(ji,jj,1) = tn(ji,jj,1)
-               ! sb(ji,jj,1) = sn(ji,jj,1)
-            END DO
-         END DO
-         
-         
-         !  tfu: Melting point of sea water
-         tfu(:,:)  = ztf   
-         
-         tfu(:,:)  = ABS ( rt0 - 0.0575       * sss_ini(:,:)                               &
-              &                    + 1.710523e-03 * sss_ini(:,:) * SQRT( sss_ini(:,:) )    &
-              &                    - 2.154996e-04 * sss_ini(:,:) * sss_ini(:,:) )
-      ELSE                     !
-
+ 
+      CALL lim_istate_init     !  reading the initials parameters of the ice
+
+      IF( .NOT. ln_limini ) THEN  
          
          ! Initialisation at tn or -2 if ice
@@ -117,18 +79,9 @@
             END DO
          END DO
-         
-         u_io  (:,:) = 0.e0
-         v_io  (:,:) = 0.e0
-         sst_io(:,:) = ( nfice - 1 ) * ( tn(:,:,1) + rt0 )   ! use the ocean initial values
-         sss_io(:,:) = ( nfice - 1 ) *   sn(:,:,1)           ! tricky trick *(nfice-1) !
-         
-         ! reference salinity 34psu
+                  
+         !  tfu: Melting point of sea water [Kelvin]
          zs0 = 34.e0
-         ztf = ABS ( rt0 - 0.0575       * zs0                           &
-              &                    + 1.710523e-03 * zs0 * SQRT( zs0 )   &
-              &                    - 2.154996e-04 * zs0 *zs0          )
-         
-         !  tfu: Melting point of sea water
-         tfu(:,:)  = ztf   
+         ztf = rt0 + ( - 0.0575 + 1.710523e-3 * SQRT( zs0 ) - 2.154996e-4 * zs0 ) * zs0
+         tfu(:,:) = ztf
          
          DO jj = 1, jpj
@@ -153,10 +106,11 @@
          tbif  (:,:,2) = tfu(:,:)
          tbif  (:,:,3) = tfu(:,:)
-      
+
       ENDIF
+     
       fsbbq (:,:)   = 0.e0
       qstoif(:,:)   = 0.e0
-      u_ice (:,:)   = 0.e0
-      v_ice (:,:)   = 0.e0
+      ui_ice(:,:)   = 0.e0
+      vi_ice(:,:)   = 0.e0
 # if defined key_coupled
       albege(:,:)   = 0.8 * tms(:,:)
@@ -192,5 +146,5 @@
 
       CALL lbc_lnk( hsnif, 'T', 1. )
-      CALL lbc_lnk( sist , 'T', 1. )
+      CALL lbc_lnk( sist , 'T', 1. , pval = rt0 )      ! set rt0 on closed boundary (required by bulk formulation)
       DO jk = 1, jplayersp1
          CALL lbc_lnk(tbif(:,:,jk), 'T', 1. )
@@ -198,6 +152,5 @@
       CALL lbc_lnk( fsbbq  , 'T', 1. )
       CALL lbc_lnk( qstoif , 'T', 1. )
-      CALL lbc_lnk( sss_io , 'T', 1. )
-      !
+
    END SUBROUTINE lim_istate
 
@@ -210,8 +163,5 @@
       !!
       !! ** Method  :   Read the namiceini namelist and check the parameter 
-      !!                values called at the first timestep (nit000)
-      !!                or
-      !!                Read 7 variables from a previous restart file
-      !!                sst, sst, hicif, hsnif, frld, ts & tbif
+      !!       values called at the first timestep (nit000)
       !!
       !! ** input   :   Namelist namiceini
@@ -223,43 +173,34 @@
          &                hnins, hgins, alins
       !!-------------------------------------------------------------------
-      
-      ! Read Namelist namiceini 
-      REWIND ( numnam_ice )
+      !
+      REWIND ( numnam_ice )               ! Read Namelist namiceini 
       READ   ( numnam_ice , namiceini )
-      
-      IF(.NOT. ln_limini) THEN 
-         IF(lwp) THEN
-            WRITE(numout,*)
-            WRITE(numout,*) 'lim_istate_init : ice parameters inititialisation '
-            WRITE(numout,*) '~~~~~~~~~~~~~~~'
-            WRITE(numout,*) '         threshold water temp. for initial sea-ice    ttest      = ', ttest
-            WRITE(numout,*) '         initial snow thickness in the north          hninn      = ', hninn
-            WRITE(numout,*) '         initial ice thickness in the north           hginn      = ', hginn 
-            WRITE(numout,*) '         initial leads area in the north              alinn      = ', alinn            
-            WRITE(numout,*) '         initial snow thickness in the south          hnins      = ', hnins 
-            WRITE(numout,*) '         initial ice thickness in the south           hgins      = ', hgins
-            WRITE(numout,*) '         initial leads area in the south              alins      = ', alins
-         ENDIF
+
+      IF(lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'lim_istate_init : ice parameters inititialisation '
+         WRITE(numout,*) '~~~~~~~~~~~~~~~'
+         WRITE(numout,*) '         threshold water temp. for initial sea-ice    ttest      = ', ttest
+         WRITE(numout,*) '         initial snow thickness in the north          hninn      = ', hninn
+         WRITE(numout,*) '         initial ice thickness in the north           hginn      = ', hginn 
+         WRITE(numout,*) '         initial leads area in the north              alinn      = ', alinn            
+         WRITE(numout,*) '         initial snow thickness in the south          hnins      = ', hnins 
+         WRITE(numout,*) '         initial ice thickness in the south           hgins      = ', hgins
+         WRITE(numout,*) '         initial leads area in the south              alins      = ', alins
+         WRITE(numout,*) '         Ice state initialization using input file    ln_limini  = ', ln_limini
       ENDIF
 
       IF( ln_limini ) THEN                      ! Ice initialization using input file
-
+         !
          CALL iom_open( 'Ice_initialization.nc', inum_ice )
-
+         !
          IF( inum_ice > 0 ) THEN
-            IF(lwp) THEN
-               WRITE(numout,*) ' '
-               WRITE(numout,*) 'lim_istate_init : ice state initialization with : Ice_initialization.nc'
-               WRITE(numout,*) '~~~~~~~~~~~~~~~'
-               WRITE(numout,*) '         Ice state initialization using input file    ln_limini  = ', ln_limini
-               WRITE(numout,*) ' '
-            ENDIF
+            IF(lwp) WRITE(numout,*)
+            IF(lwp) WRITE(numout,*) '                  ice state initialization with : Ice_initialization.nc'
             
-            CALL iom_get( inum_ice, jpdom_data, 'sst'  , sst_ini(:,:) )        
-            CALL iom_get( inum_ice, jpdom_data, 'sss'  , sss_ini(:,:) )       
-            CALL iom_get( inum_ice, jpdom_data, 'hicif', hicif  (:,:) )      
-            CALL iom_get( inum_ice, jpdom_data, 'hsnif', hsnif  (:,:) )      
-            CALL iom_get( inum_ice, jpdom_data, 'frld' , frld   (:,:) )     
-            CALL iom_get( inum_ice, jpdom_data, 'ts'   , sist   (:,:) )
+            CALL iom_get( inum_ice, jpdom_data, 'hicif', hicif )      
+            CALL iom_get( inum_ice, jpdom_data, 'hsnif', hsnif )      
+            CALL iom_get( inum_ice, jpdom_data, 'frld' , frld  )     
+            CALL iom_get( inum_ice, jpdom_data, 'ts'   , sist  )
             CALL iom_get( inum_ice, jpdom_unknown, 'tbif', tbif(1:nlci,1:nlcj,:),   &
                  &        kstart = (/ mig(1),mjg(1),1 /), kcount = (/ nlci,nlcj,jplayersp1 /) )
@@ -269,8 +210,8 @@
 
             CALL iom_close( inum_ice)
-            
+            !
          ENDIF
       ENDIF
-      !
+      !     
    END SUBROUTINE lim_istate_init
 
Index: trunk/NEMO/LIM_SRC/limrhg.F90
===================================================================
--- trunk/NEMO/LIM_SRC/limrhg.F90	(revision 716)
+++ trunk/NEMO/LIM_SRC/limrhg.F90	(revision 717)
@@ -4,9 +4,9 @@
    !!   Ice rheology :  performs sea ice rheology
    !!======================================================================
-   !! History :   0.0  !  93-12  (M.A. Morales Maqueda.)  Original code
-   !!             1.0  !  94-12  (H. Goosse) 
-   !!             2.0  !  03-12  (C. Ethe, G. Madec)  F90, mpp
-   !!             3.0  !  07-06  (S. Masson, G. Madec)  ice/atmosphere stress
-   !!                             provided at I-point in forced and coupled mode
+   !! History :  0.0  !  93-12  (M.A. Morales Maqueda.)  Original code
+   !!            1.0  !  94-12  (H. Goosse) 
+   !!            2.0  !  03-12  (C. Ethe, G. Madec)  F90, mpp
+   !!            " "  !  06-08  (G. Madec)  surface module, ice-stress at I-point
+   !!            " "  !  09-09  (G. Madec)  Huge verctor optimisation
    !!----------------------------------------------------------------------
 #if defined key_ice_lim
@@ -14,31 +14,32 @@
    !!   'key_ice_lim'                                     LIM sea-ice model
    !!----------------------------------------------------------------------
+   !!----------------------------------------------------------------------
    !!   lim_rhg   : computes ice velocities
    !!----------------------------------------------------------------------
-   !! * Modules used
-   USE phycst
-   USE par_oce
-   USE ice_oce         ! ice variables
-   USE dom_ice
-   USE ice
-   USE lbclnk
-   USE lib_mpp
-   USE in_out_manager  ! I/O manager
-   USE prtctl          ! Print control
+   USE par_oce        ! ocean parameter
+   USE ice_oce        ! ice variables
+   USE sbc_ice        ! surface boundary condition: ice variables
+   USE dom_ice        ! domaine: ice variables
+   USE phycst         ! physical constant
+   USE ice            ! ice variables
+   USE lbclnk         ! lateral boundary condition
+   USE lib_mpp        ! MPP library
+   USE in_out_manager ! I/O manager
+   USE prtctl         ! Print control
 
    IMPLICIT NONE
    PRIVATE
 
-   !! * Routine accessibility
-   PUBLIC lim_rhg  ! routine called by lim_dyn
-
-   !! * Module variables
-   REAL(wp)  ::           &  ! constant values
-      rzero   = 0.e0   ,  &
-      rone    = 1.e0
-   !!----------------------------------------------------------------------
-   !!   LIM 2.0,  UCL-LOCEAN-IPSL (2005) 
-   !! $Id$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   PUBLIC   lim_rhg   ! routine called by lim_dyn
+
+   REAL(wp) ::   rzero   = 0.e0   ! constant value: zero
+   REAL(wp) ::   rone    = 1.e0   !            and  one
+
+   !! * Substitutions
+#  include "vectopt_loop_substitute.h90"
+   !!----------------------------------------------------------------------
+   !!   LIM 2.0,  UCL-LOCEAN-IPSL (2006) 
+   !! $Header: $
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -54,80 +55,150 @@
       !!  viscous-plastic law including shear strength and a bulk rheology.
       !!
-      !! ** Action  : - compute u_ice, v_ice the sea-ice velocity
+      !! ** Action  : - compute ui_ice, vi_ice the sea-ice velocity defined
+      !!              at I-point
+      !!-------------------------------------------------------------------
+      INTEGER, INTENT(in) ::   k_j1    ! southern j-index for ice computation
+      INTEGER, INTENT(in) ::   k_jpj   ! northern j-index for ice computation
       !!
+      INTEGER ::   ji, jj              ! dummy loop indices
+      INTEGER ::   iter, jter          ! temporary integers
+      CHARACTER (len=50) ::   charout
+      REAL(wp) ::   ze11  , ze12  , ze22  , ze21       ! temporary scalars
+      REAL(wp) ::   zt11  , zt12  , zt21  , zt22       !    "         "
+      REAL(wp) ::   zvis11, zvis21, zvis12, zvis22     !    "         "
+      REAL(wp) ::   zgphsx, ztagnx, zunw, zur, zusw    !    "         "
+      REAL(wp) ::   zgphsy, ztagny, zvnw, zvr          !    "         "
+      REAL(wp) ::   zresm,  za, zac, zmod
+      REAL(wp) ::   zmpzas, zstms, zindu, zusdtp, zmassdt, zcorlal
+      REAL(wp) ::   ztrace2, zdeter, zdelta, zmask, zdgp, zdgi, zdiag
+      REAL(wp) ::   za1, zb1, zc1, zd1
+      REAL(wp) ::   za2, zb2, zc2, zd2, zden
+      REAL(wp) ::   zs11_11, zs11_12, zs11_21, zs11_22
+      REAL(wp) ::   zs12_11, zs12_12, zs12_21, zs12_22
+      REAL(wp) ::   zs21_11, zs21_12, zs21_21, zs21_22
+      REAL(wp) ::   zs22_11, zs22_12, zs22_21, zs22_22
+      REAL(wp), DIMENSION(jpi,  jpj  ) ::   zfrld, zmass, zcorl
+      REAL(wp), DIMENSION(jpi,  jpj  ) ::   za1ct, za2ct, zresr
+      REAL(wp), DIMENSION(jpi,  jpj  ) ::   zc1u, zc1v, zc2u, zc2v
+      REAL(wp), DIMENSION(jpi,  jpj  ) ::   zsang
+      REAL(wp), DIMENSION(jpi,0:jpj+1) ::   zu0, zv0
+      REAL(wp), DIMENSION(jpi,0:jpj+1) ::   zu_n, zv_n
+      REAL(wp), DIMENSION(jpi,0:jpj+1) ::   zu_a, zv_a
+      REAL(wp), DIMENSION(jpi,0:jpj+1) ::   zviszeta, zviseta
+      REAL(wp), DIMENSION(jpi,0:jpj+1) ::   zzfrld, zztms
+      REAL(wp), DIMENSION(jpi,0:jpj+1) ::   zi1, zi2, zmasst, zpresh
+
       !!-------------------------------------------------------------------
-      INTEGER, INTENT(in) ::   k_j1 ,  &  ! southern j-index for ice computation
-         &                     k_jpj      ! northern j-index for ice computation
-
-      INTEGER ::   ji, jj              ! dummy loop indices
-
-      INTEGER  :: &
-         iim1, ijm1, iip1 , ijp1   , & ! temporary integers
-         iter, jter                    !    "          "
-
-      CHARACTER (len=50) :: charout
-
-      REAL(wp) :: &
-         ze11  , ze12  , ze22  , ze21  ,   &  ! temporary scalars
-         zt11  , zt12  , zt21  , zt22  ,   &  !    "         "
-         zvis11, zvis21, zvis12, zvis22,   &  !    "         "
-         zgphsx, ztagnx, zusw  ,           &  !    "         "
-         zgphsy, ztagny                       !    "         "
-      REAL(wp) :: &
-         zresm, zunw, zvnw, zur, zvr, zmod, za, zac, &
-         zmpzas, zstms, zindu, zindu1, zusdtp, zmassdt, zcorlal,  &
-         ztrace2, zdeter, zdelta, zsang, zmask, zdgp, zdgi, zdiag, zic
-      REAL(wp),DIMENSION(jpi,jpj) ::   &
-         zpresh, zfrld, zmass, zcorl,     &
-         zu0, zv0, zviszeta, zviseta,     &
-         zc1u, zc1v, zc2u, zc2v, za1ct, za2ct, za1, za2, zb1, zb2,  &
-         zc1, zc2, zd1, zd2, zden, zu_ice, zv_ice, zresr
-      REAL(wp),DIMENSION(jpi,jpj,2,2) :: &
-         zs11, zs12, zs22, zs21
-      !!-------------------------------------------------------------------
+
+!!bug
+!!    ui_oce(:,:) = 0.e0
+!!    vi_oce(:,:) = 0.e0
+!!    write(*,*) 'rhg min, max u & v', maxval(ui_oce), minval(ui_oce), maxval(vi_oce), minval(vi_oce)
+!!bug
       
       !  Store initial velocities
-      !  ------------------------
-      zu0(:,:) = u_ice(:,:)
-      zv0(:,:) = v_ice(:,:)
-
-      ! masked Ice mass, ice strength, Ice-cover fraction and Lead faction  at T-point 
+      !  ----------------
+      zztms(:,0    ) = 0.e0       ;    zzfrld(:,0    ) = 0.e0
+      zztms(:,jpj+1) = 0.e0       ;    zzfrld(:,jpj+1) = 0.e0
+      zu0(:,0    ) = 0.e0         ;    zv0(:,0    ) = 0.e0
+      zu0(:,jpj+1) = 0.e0         ;    zv0(:,jpj+1) = 0.e0
+      zztms(:,1:jpj) = tms(:,:)   ;    zzfrld(:,1:jpj) = frld(:,:)
+      zu0(:,1:jpj) = ui_ice(:,:)   ;    zv0(:,1:jpj) = vi_ice(:,:)
+
+      zu_a(:,:)    = zu0(:,:)     ;   zv_a(:,:) = zv0(:,:)
+      zu_n(:,:)    = zu0(:,:)     ;   zv_n(:,:) = zv0(:,:)
+
+!i
+      zi1   (:,:) = 0.e0
+      zi2   (:,:) = 0.e0
+      zpresh(:,:) = 0.e0
+      zmasst(:,:) = 0.e0
+!i
+!!gm violant
+      zfrld(:,:) =0.e0
+      zcorl(:,:) =0.e0
+      zmass(:,:) =0.e0
+      za1ct(:,:) =0.e0
+      za2ct(:,:) =0.e0
+!!gm end
+
+      zviszeta(:,:) = 0.e0
+      zviseta (:,:) = 0.e0
+
+!i    zviszeta(:,0    ) = 0.e0    ;    zviseta(:,0    ) = 0.e0
+!i    zviszeta(:,jpj  ) = 0.e0    ;    zviseta(:,jpj  ) = 0.e0
+!i    zviszeta(:,jpj+1) = 0.e0    ;    zviseta(:,jpj+1) = 0.e0
+
+
+      ! Ice mass, ice strength, and wind stress at the center            |
+      ! of the grid squares.                                             |
       !-------------------------------------------------------------------
 
+!CDIR NOVERRCHK
       DO jj = k_j1 , k_jpj-1
+!CDIR NOVERRCHK
          DO ji = 1 , jpi
-            za1(ji,jj)    = tms(ji,jj) * ( rhosn * hsnm(ji,jj) + rhoic * hicm(ji,jj) )
+            ! only the sinus changes its sign with the hemisphere
+            zsang(ji,jj)  = SIGN( 1.e0, fcor(ji,jj) ) * sangvg   ! only the sinus changes its sign with the hemisphere
+            !
+            zmasst(ji,jj) = tms(ji,jj) * ( rhosn * hsnm(ji,jj) + rhoic * hicm(ji,jj) )
             zpresh(ji,jj) = tms(ji,jj) *  pstarh * hicm(ji,jj) * EXP( -c_rhg * frld(ji,jj) )
-
-            zb1(ji,jj)    = tms(ji,jj) * ( 1.0 - frld(ji,jj) )    
-            zb2(ji,jj)    = tms(ji,jj) *         frld(ji,jj)      
+!!gm  :: stress given at I-point (F-point for the ocean) only compute the ponderation with the ice fraction (1-frld)
+            zi1(ji,jj)    = tms(ji,jj) * ( 1.0 - frld(ji,jj) )
+            zi2(ji,jj)    = tms(ji,jj) * ( 1.0 - frld(ji,jj) )
+
+!!gm   #if defined key_lim_cp1 && defined key_coupled
+!!gm        zi1(ji,jj)    = tms(ji,jj) * gtaux(ji,jj) * ( 1.0 - frld(ji,jj) )
+!!gm        zi2(ji,jj)    = tms(ji,jj) * gtauy(ji,jj) * ( 1.0 - frld(ji,jj) )
+!!gm   #else
+!!gm        zi1(ji,jj)    = tms(ji,jj) * ( 1.0 - frld(ji,jj) )
+!!gm        zi2(ji,jj)    = tms(ji,jj) * ( 1.0 - frld(ji,jj) )
+!!gm   #endif
          END DO
       END DO
 
-      !  Wind stress, coriolis, mass and Gradient of ice strenght at I-point
+
+      !---------------------------------------------------------------------------
+      !  Wind stress, coriolis and mass terms at the corners of the grid squares |
+      !  Gradient of ice strenght.                                               |
       !---------------------------------------------------------------------------
          
       DO jj = k_j1+1, k_jpj-1
-         DO ji = 2, jpi
-            zstms = tms(ji,jj  ) * wght(ji,jj,2,2) + tms(ji-1,jj  ) * wght(ji,jj,1,2)   &
-               &  + tms(ji,jj-1) * wght(ji,jj,2,1) + tms(ji-1,jj-1) * wght(ji,jj,1,1)
+         DO ji = fs_2, jpi
+            zstms = zztms(ji,jj  ) * wght(ji,jj,2,2) + zztms(ji-1,jj  ) * wght(ji,jj,1,2)   &
+               &  + zztms(ji,jj-1) * wght(ji,jj,2,1) + zztms(ji-1,jj-1) * wght(ji,jj,1,1)
             zusw  = 1.0 / MAX( zstms, epsd )
 
-            ! Leads area at I-point
-            zfrld(ji,jj) = ( zb2(ji,jj  ) * wght(ji,jj,2,2) + zb2(ji-1,jj  ) * wght(ji,jj,1,2)   &
-               &           + zb2(ji,jj-1) * wght(ji,jj,2,1) + zb2(ji-1,jj-1) * wght(ji,jj,1,1) ) * zusw
-
-            ! Ice cover area at I-point
-            zic          = ( zb1(ji,jj  ) * wght(ji,jj,2,2) + zb1(ji-1,jj  ) * wght(ji,jj,1,2)   &
-               &           + zb1(ji,jj-1) * wght(ji,jj,2,1) + zb1(ji-1,jj-1) * wght(ji,jj,1,1) ) * zusw
+            zt11 = zztms(ji  ,jj  ) * zzfrld(ji  ,jj  ) 
+            zt12 = zztms(ji-1,jj  ) * zzfrld(ji-1,jj  ) 
+            zt21 = zztms(ji  ,jj-1) * zzfrld(ji  ,jj-1) 
+            zt22 = zztms(ji-1,jj-1) * zzfrld(ji-1,jj-1)
+
+            ! Leads area.
+            zfrld(ji,jj) =  (  zt11 * wght(ji,jj,2,2) + zt12 * wght(ji,jj,1,2)   &
+               &             + zt21 * wght(ji,jj,2,1) + zt22 * wght(ji,jj,1,1) ) * zusw
+
+            ! Mass and coriolis coeff. at I-point
+            zmass(ji,jj) = ( zmasst(ji,jj  ) * wght(ji,jj,2,2) + zmasst(ji-1,jj  ) * wght(ji,jj,1,2)   &
+               &           + zmasst(ji,jj-1) * wght(ji,jj,2,1) + zmasst(ji-1,jj-1) * wght(ji,jj,1,1) ) * zusw
+            zcorl(ji,jj) = zmass(ji,jj) * fcor(ji,jj)
 
             ! Wind stress.
-            ztagnx = zic * gtaux(ji,jj)
-            ztagny = zic * gtauy(ji,jj)
-
-            ! Mass and coriolis coeff.
-            zmass(ji,jj) = ( za1(ji,jj  ) * wght(ji,jj,2,2) + za1(ji-1,jj  ) * wght(ji,jj,1,2)   &
-               &           + za1(ji,jj-1) * wght(ji,jj,2,1) + za1(ji-1,jj-1) * wght(ji,jj,1,1) ) * zusw
-            zcorl(ji,jj) = zmass(ji,jj) * fcor(ji,jj)
+!!gm   #if defined key_lim_cp1 && defined key_coupled
+!!gm   ztagnx = ( zi1(ji,jj  ) * wght(ji,jj,2,2) + zi1(ji-1,jj  ) * wght(ji,jj,1,2)   &
+!!gm      &     + zi1(ji,jj-1) * wght(ji,jj,2,1) + zi1(ji-1,jj-1) * wght(ji,jj,1,1) ) * zusw
+!!gm   ztagny = ( zi2(ji,jj  ) * wght(ji,jj,2,2) + zi2(ji-1,jj  ) * wght(ji,jj,1,2)   &
+!!gm      &     + zi2(ji,jj-1) * wght(ji,jj,2,1) + zi2(ji-1,jj-1) * wght(ji,jj,1,1) ) * zusw
+!!gm   #else
+!!gm   ztagnx = ( zi1(ji,jj  ) * wght(ji,jj,2,2) + zi1(ji-1,jj  ) * wght(ji,jj,1,2)   &
+!!gm      &     + zi1(ji,jj-1) * wght(ji,jj,2,1) + zi1(ji-1,jj-1) * wght(ji,jj,1,1) ) * zusw * gtaux(ji,jj)
+!!gm   ztagny = ( zi2(ji,jj  ) * wght(ji,jj,2,2) + zi2(ji-1,jj  ) * wght(ji,jj,1,2)   &
+!!gm      &     + zi2(ji,jj-1) * wght(ji,jj,2,1) + zi2(ji-1,jj-1) * wght(ji,jj,1,1) ) * zusw * gtauy(ji,jj)
+!!gm   #endif
+            !!gm  always stress provided at I-point (ocean F-point)
+            ztagnx = ( zi1(ji,jj  ) * wght(ji,jj,2,2) + zi1(ji-1,jj  ) * wght(ji,jj,1,2)   &
+               &     + zi1(ji,jj-1) * wght(ji,jj,2,1) + zi1(ji-1,jj-1) * wght(ji,jj,1,1) ) * zusw * utaui_ice(ji,jj)
+            ztagny = ( zi2(ji,jj  ) * wght(ji,jj,2,2) + zi2(ji-1,jj  ) * wght(ji,jj,1,2)   &
+               &     + zi2(ji,jj-1) * wght(ji,jj,2,1) + zi2(ji-1,jj-1) * wght(ji,jj,1,1) ) * zusw * vtaui_ice(ji,jj)
 
             ! Gradient of ice strength
@@ -143,13 +214,9 @@
 
             ! Computation of the velocity field taking into account the ice-ice interaction.                                 
-            ! Terms that are independent of the velocity field.
-            za1ct(ji,jj) = ztagnx - zcorl(ji,jj) * v_io(ji,jj) - zgphsx
-            za2ct(ji,jj) = ztagny + zcorl(ji,jj) * u_io(ji,jj) - zgphsy
+            ! Terms that are independent of the ice velocity field.
+            za1ct(ji,jj) = ztagnx - zcorl(ji,jj) * vi_oce(ji,jj) - zgphsx
+            za2ct(ji,jj) = ztagny + zcorl(ji,jj) * ui_oce(ji,jj) - zgphsy
          END DO
       END DO
-
-!! inutile!!
-!!??    CALL lbc_lnk( za1ct, 'I', -1. )
-!!??    CALL lbc_lnk( za2ct, 'I', -1. )
 
 
